

typedef struct Time {
        short seconds;
        short minutes;
        short hours;
        short day;
        short month;
        int year;
} TTime;
TTime MyTime, CurrentTime, CurrentAlarm,  AlarmTime;


void Set_RTC(TTime *RTCC_Time, TTime *ALARM_Time){
    unsigned long temp_time = 0, temp_date = 0, temp_alarm_time = 0, temp_alarm_date = 0;
    
    RTCCIE_bit = 0;

    temp_time = (unsigned long)Dec2Bcd(RTCC_Time->hours) << 24;
    temp_time += (unsigned long)Dec2BCD(RTCC_Time->minutes) << 16;
    temp_time += (unsigned long)Dec2BCD(RTCC_Time->seconds) << 8;

    temp_date = (unsigned long)Dec2Bcd(RTCC_Time->year) << 24;
    temp_date += (unsigned long)Dec2BCD(RTCC_Time->month) << 16;
    temp_date += (unsigned long)Dec2BCD(RTCC_Time->day) << 8;

    temp_alarm_time = (unsigned long)Dec2Bcd(ALARM_Time->hours) << 24;
    temp_alarm_time += (unsigned long)Dec2BCD(ALARM_Time->minutes) << 16;
    temp_alarm_time += (unsigned long)Dec2BCD(ALARM_Time->seconds) << 8;

    temp_alarm_date = (unsigned long)Dec2Bcd(ALARM_Time->year) << 24;
    temp_alarm_date += (unsigned long)Dec2BCD(ALARM_Time->month) << 16;
    temp_alarm_date += (unsigned long)Dec2BCD(ALARM_Time->day) << 8;



    SYSKEY = 0xAA996655;       // RTCC registers unlock procedure
    SYSKEY = 0x556699AA;

    RTCWREN_bit = 1;           // RTC Value registers can be written to by the user

    ON__RTCCON_bit = 0;        // Turn off the RTCC module

    while (RTCCLKON_bit)       // Wait for clock to be turned off
            ;

      RTCTIME = temp_time;
      RTCDATE = temp_date;

    while (ALRMSYNC_bit)       // Wait for alarm clock to be turned off
            ;

    RTCALRMCLR=0xCFFF; // clear ALRMEN, CHIME, AMASK and ARPT;
   
    ALRMTIMECLR = 0xFFFFFFFF;
    ALRMDATECLR = 0xFFFFFFFF;

    ALRMTIME = temp_alarm_time;
    ALRMDATE = temp_alarm_date;
    
    RTCALRMSET = 0x8600;
 
    RTSECSEL_bit = 0;         // Use RTC interrupt
    
    ON__RTCCON_bit = 1;        // Turn on the RTCC module
    while (!RTCCLKON_bit)      // Wait for clock to be turned on
            ;

    RTCCIF_bit = 0;
    RTCCIE_bit = 1;
}

void RTC_Init(){

    SYSKEY = 0x0;
    SYSKEY = 0xAA996655;
    SYSKEY = 0x556699AA;

    CLKLOCK_bit = 0;
    SOSCEN_bit = 1;        // enable seconday oscillator
    OSWEN_bit = 1;

    SLPEN_bit = 1;
    SYSKEY = 0x0;

    RTCCIP0_bit = 1;       // Set RTCC interrupt
    RTCCIP1_bit = 1;       // priority level
    RTCCIP2_bit = 1;       // to 7

    MyTime.seconds = 0;
    MyTime.minutes = 0;
    MyTime.hours = 11;
    MyTime.day = 1;
    MyTime.month = 11;
    MyTime.year = 11;

    // Alarm setting !!! Change alarm Time here
    AlarmTime.seconds = 10;
    AlarmTime.minutes = 0;
    AlarmTime.hours = 11;
    AlarmTime.day = 1;
    AlarmTime.month = 11;
    AlarmTime.year = 11;

    Set_RTC(&MyTime, &AlarmTime);
}